<svelte:component this={ component } { ...props }/>

<script context="module">
  import get from 'lodash/get';
  import { router as store } from '../../store';

  let router = new RouterRecognizer();
  const LoadRoute = async path => {
    const matchedPath = router.recognize(path);
    const handler = get(matchedPath, '[0].handler', () => {});
    const params = get(matchedPath, '[0].params', {});
    const module = await handler();
    
    store.set({ module: module.default, params });
  };
  window.onpopstate = () => LoadRoute(window.location.pathname);
</script>

<script>
  import RouterRecognizer from 'route-recognizer';
  import { onMount } from 'svelte';

  let component = null;
  let props = null;
  export let routes = [];

  store.subscribe(state => {
    component = state.module;
    props = state.params;
  });

  routes.forEach(route => router.add([route]));
  onMount(() => LoadRoute(window.location.pathname));
</script>


